#ifndef _CPDOCCORE_ODF_OFFCIE_ELEMENTS_TYPE_H_
#define _CPDOCCORE_ODF_OFFCIE_ELEMENTS_TYPE_H_

namespace cpdoccore { 
namespace odf_writer {

enum ElementType
{
    typeNone = 0,
    type_AbstractXml,

    typeTextText = 1000,
    typeTextS,
    typeTextTab,
    typeTextLineBreak,
    typeTextBookmark,
    typeTextBookmarkStart,
    typeTextBookmarkEnd,
    typeTextReferenceMark,
    typeTextReferenceMarkStart,
    typeTextReferenceMarkEnd,
    typeTextSpan,
    typeTextA,
    typeTextNote,
    typeTextNoteCitation,
    typeTextNoteBody,
    typeTextRuby,
    typeTextRubyBase,
    typeTextRubyText,
    typeTextOfficeAnnotation,
    typeTextTitle,
    typeTextPlaceholder,
    typeTextPageNumber,
    typeTextPageCount,
    typeTextDate,
    typeTextTime,
    typeTextFileName,
    typeTextSequence,
    typeTextSheetName,

	typePresentationFooter,
	typePresentationDateTime,

	typeDcCreator,
	typeDcDate,

    typeTextH,
    typeTextP,

    typeTextList,
    typeTextListItem,
    typeTextListHeader,
    typeTextNumber,
    typeTextSoftPageBreak,
    typeTextSection,
    typeTextSectionSource,
    typeTextIndexTitle,
    typeTextIndexBody,

    typeTextNumberedParagraph,    
   
    typeDrawA,

    typeTextTableOfContent,
    typeTextIllustrationIndex,
    typeTextTableIndex,
    typeTextObjectIndex,
    typeTextUserIndex,
    typeTextAlphabeticalIndex,
    typeTextBibliography,
    typeShape,
    typeChangeMarks,

    typeOfficeAutomaticStyles,
    typeOfficeMasterStyles,
    typeStyleMasterPage,
    typeStyleHandoutMasterPage,
	typeStyleDrawLayerSet,
    typeOfficeStyles,
    typeStyleDefaultStyle,
    typeStyleStyle,
    typeTextListStyle,
	typeTextListLevelStyleImage,
    typeTextListLevelStyleNumber,
    typeTextListLevelStyleBullet,
    typeStyleListLevelProperties,
    typeStyleListLevelLabelAlignment,

    typeStyleTabStop,
    typeStyleTabStops,
    typeStyleDropCap,
    typeStyleBackgroundImage,
    typeStyleTextProperties,
    typeStyleParagraphProperties,
    typeStyleTableProperties,
    typeStyleTableColumnProperties,
    typeStyleTableRowProperties,
    typeStyleTableCellProperties,
    typeStyleHeader,
    typeStyleFooter,
    typeStyleHeaderFirst,
    typeStyleFooterFirst,
	typeStyleHeaderLeft,
    typeStyleFooterLeft,
    typeStyleFootnoteSep,

    typeStyleSectionProperties,
    typeStyleHeaderStyle,
    typeStyleFooterStyle,
	typeStyleHeaderFooterProperties,

	typeStylePresentationPageLayout,
	typeStylePresentationPlaceholder,
	typeStyleDrawingPageProperties,
	
	typePresentationNotes,

    typeStyleColumns,
    typeStyleColumn,
    typeStyleColumnSep,

    typeStylePageLayout,
    typeStyleMap,

	typeTableBodyTemplate,
	typeTableTemplate,

    typeTextNotesConfiguration,

    typeStyleFontFace,

    typeSvgFontFaceUri,
    typeSvgFontFaceFormat,
    typeSvgFontFaceName,
    typeSvgDefinitionSrc,
    typeOfficeFontFaceDecls,

    typeOfficeBinaryData,
    typeOfficeForms,

    typeTableTableSource,
    typeTableNamedExpressions,
    typeTableNamedExpression,
    typeTableNamedRange,
	typeTableDatabaseRanges,
	typeTableDatabaseRange,
    typeTableTable,
    typeTableTableColumn,
    typeTableTableColumns,
    typeTableTableHeaderColumns,
    typeTableTableColumnGroup,
    typeTableTableRow,
    typeTableTableCell,
    typeTableCoveredTableCell,
    typeTableTableRows,
    typeTableTableHeaderRows,
    typeTableTableRowGroup,
	typeTableTableRowNoGroup,
        
    typeOfficeBody,
    typeOfficeText,
    typeOfficeDocument,
    typeOfficeDocumentContent,
    typeOfficeDocumentStyles,
    typeOfficeDocumentMeta,
    typeOfficeDocumentSettings,

	typeManifest,
	typeManifestEntry,
	typeManifestEncryptionData,

	typeOfficeSettings,
	typeOfficeSettingsConfigItemSet,
	typeOfficeSettingsConfigItem,
	typeOfficeSettingsConfigItemMapIndexed,
	typeOfficeSettingsConfigItemMapNamed,
  	typeOfficeSettingsConfigItemMapEntry,

 	typeDrawG,
	typeDrawFrame,
    typeDrawImage,
    typeDrawTextBox,
    typeDrawObject,
    typeDrawObjectOle,
 	typeDrawChart,

	typeDrawBase,
	typeDrawShape,

	typeDrawRect,
	typeDrawEllipse,
	typeDrawLine,
	typeDrawPolygon,
	typeDrawPolyline,
	typeDrawRegularPolyline,
	typeDrawPath,
	typeDrawCircle,
	typeDrawg,
	typeDrawPageThumbnail,
	typeDrawMeasure,
	typeDrawCaption,
	typeDrawConnector,
	typeDrawControl,
	typeDraw3dScene,
	typeDrawCustomShape,
	typeDrawHandle,
	typeDrawEquation,
	typeDrawEnhancedGeometry,

	typeDrawPage,    
	typePresentationFooterDecl,
	typePresentationDateTimeDecl,

	typeAnimPar,
	typeAnimSeq,
	typeAnimTransitionFilter,

	typeStyleGraphicPropertis,
	typeStyleDrawGradient,
	typeStyleDrawFillImage,
	typeStyleDrawHatch,
	typeStyleDrawMarker,
	typeStyleDrawOpacity,
	typeStyleDrawStrokeDash,

	typeOfficeSpreadsheet,
	typeOfficeAnnotation,
	typeOfficeAnnotationEnd,
	typeStyleRegionLeft,
	typeOfficeScripts,
	typeOfficeScript,
	typeOfficePresentation,
	typeOfficeChart,
	typeOfficeEventListeners,

	typeCalcextConditionalFormats,
	typeCalcextConditionalFormat,
	typeCalcextIconSet,
	typeCalcextDataBar,
	typeCalcextColorScale,
	typeCalcextCondition,
	typeCalcextDateIs,
	typeCalcextFormattingEntry,
	typeCalcextColorScaleEntry,
  
	typePresentationEventListener,	

	typeScriptEventListener,

	typeTableCalculationSettings,
    typeTableNullDate,

    typeNumberNumberStyle,
    typeNumberDataStyle,
    typeNumberText,
    typeNumberNumber,
    typeNumberEmbeddedText,
    typeNumberScientificNumber,
    typeNumberFraction,
    typeNumberCurrencyStyle,
    typeNumberCurrencySymbol,
    typeNumberTextContent,
    typeNumberTextStyle,
    typeNumberPercentageStyle,
    typeNumberTimeStyle,
    typeNumberDay,
    typeNumberMonth,
    typeNumberYear,
    typeNumberDayOfWeek,
    typeNumberQuarter,
    typeNumberHours,
    typeNumberMinutes,
    typeNumberSeconds,
    typeNumberAmPm,
    typeTableShapes,

    typeChartChart,
    typeChartTitle,
    typeChartSubtitle,
    typeChartFooter,
    typeChartLegend,
    typeChartPlotArea,
    typeChartWall,
    typeChartFloor,
    typeChartAxis,
    typeChartGrid,
    typeChartCategories,
    typeChartSeries,
    typeChartDomain,
    typeChartDataPoint,
    typeChartErrorIndicator,
    typeChartMeanValue,
    typeChartStockGainMarker,
    typeChartStockLossMarker,
    typeChartStockRangeLine,
	typeChartRegressionCurve,
	typeChartEquation,

	typeStyleRegionCenter,
    typeStyleRegionRight,
	typeStyleChartProperties

};


}
}

#endif // #ifndef _CPDOCCORE_ODF_OFFCIE_ELEMENTS_TYPE_H_
